/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationBlockingData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationBlockingData{}

// ConversationBlockingData struct for ConversationBlockingData
type ConversationBlockingData struct {
	Blocked bool `json:"blocked"`
	BlockedInfo *string `json:"blocked_info,omitempty"`
}

// NewConversationBlockingData instantiates a new ConversationBlockingData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationBlockingData(blocked bool) *ConversationBlockingData {
	this := ConversationBlockingData{}
	this.Blocked = blocked
	return &this
}

// NewConversationBlockingDataWithDefaults instantiates a new ConversationBlockingData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationBlockingDataWithDefaults() *ConversationBlockingData {
	this := ConversationBlockingData{}
	return &this
}

// GetBlocked returns the Blocked field value
func (o *ConversationBlockingData) GetBlocked() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value
// and a boolean to check if the value has been set.
func (o *ConversationBlockingData) GetBlockedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Blocked, true
}

// SetBlocked sets field value
func (o *ConversationBlockingData) SetBlocked(v bool) {
	o.Blocked = v
}

// GetBlockedInfo returns the BlockedInfo field value if set, zero value otherwise.
func (o *ConversationBlockingData) GetBlockedInfo() string {
	if o == nil || IsNil(o.BlockedInfo) {
		var ret string
		return ret
	}
	return *o.BlockedInfo
}

// GetBlockedInfoOk returns a tuple with the BlockedInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationBlockingData) GetBlockedInfoOk() (*string, bool) {
	if o == nil || IsNil(o.BlockedInfo) {
		return nil, false
	}
	return o.BlockedInfo, true
}

// HasBlockedInfo returns a boolean if a field has been set.
func (o *ConversationBlockingData) HasBlockedInfo() bool {
	if o != nil && !IsNil(o.BlockedInfo) {
		return true
	}

	return false
}

// SetBlockedInfo gets a reference to the given string and assigns it to the BlockedInfo field.
func (o *ConversationBlockingData) SetBlockedInfo(v string) {
	o.BlockedInfo = &v
}

func (o ConversationBlockingData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationBlockingData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["blocked"] = o.Blocked
	if !IsNil(o.BlockedInfo) {
		toSerialize["blocked_info"] = o.BlockedInfo
	}
	return toSerialize, nil
}

type NullableConversationBlockingData struct {
	value *ConversationBlockingData
	isSet bool
}

func (v NullableConversationBlockingData) Get() *ConversationBlockingData {
	return v.value
}

func (v *NullableConversationBlockingData) Set(val *ConversationBlockingData) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationBlockingData) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationBlockingData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationBlockingData(val *ConversationBlockingData) *NullableConversationBlockingData {
	return &NullableConversationBlockingData{value: val, isSet: true}
}

func (v NullableConversationBlockingData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationBlockingData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


